//+------------------------------------------------------------------+
//|                                       Support and Resistance.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Aaragorn"
#property link      "http://www.forex-tsd.com/members/aaragorn.html"
// This is an attempt to locate support and resistance and determine it's relative strength
// At NumberOfBars = 300 ; this EA is doing over 360,000 arithmetical calculations for each bar.
// This is only looking at horizontal lines not sloping trendlines. The goal is not simply to look at
// support and resistance as the highest highs or lowest lows but based on the actual opens and closes.
 
extern int NumberOfBars = 12;
#define SIZE 12  // must be set to match NumberOfBars
static int Index = 0;
//used in the tally loops
static double Opens[ SIZE ] = { 0 };
static double Closes[ SIZE ] = { 0 };

static double OpenOLevels[ SIZE ] = { 0 };
static double OpenCLevels[ SIZE ] = { 0 };
static double CloseOLevels[ SIZE ] = { 0 };
static double CloseCLevels[ SIZE ] = { 0 };

static double OpenOMatches[ SIZE ] = { 0 };
static double OpenCMatches[ SIZE ] = { 0 };
static double CloseOMatches[ SIZE ] = { 0 };
static double CloseCMatches[ SIZE ] = { 0 };

// Used to concatenate the results
static int TotalOMatches[ SIZE ] = { 0 };
static int TotalCMatches[ SIZE ] = { 0 };
static int OpensInt[ SIZE ] = { 0 };//this is specific to the pairs which are formatted with 4 decimals like "1.2345" they are multiplied by 10000 to preserve the decimal
static int ClosesInt[ SIZE ] = { 0 };//this is specific to the pairs which are formatted with 4 decimals like "1.2345" they are multiplied by 10000 to preserve the decimal

// Used to recombine after concatenation
static double OpenConcats[ SIZE ] = { 0 };
static double CloseConcats[ SIZE ] = { 0 };
static double CombinedConcats[ SIZE ] = { 0 };
static double ONotEqualCConcats[ SIZE ] = { 0 };
int ConcatTracker = 0;

//not used in my current mess
//static double OpenHistogram[2][ SIZE ] = { 0 };
//static double CloseHistogram[2][ SIZE ] = { 0 };

//static double OpenHistogramLevels[ SIZE ] = { 0 };
//static double OpenHistogramMatches[ SIZE ] = { 0 };

//static double LevelStrength[ SIZE ] = { 0 };
//static double MatchStandardDeviations[ SIZE ] = { 0 };

//static double OpenLevelsandMatches[SIZE][1] = { 0 };
//static double CloseLevelsandMatches[SIZE][1] = { 0 };

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----We tally the opens and closes of the Bars

   Print("Support and Resistance EA has started");
   int i = NumberOfBars;
   while(i>0)
     {
      Opens[i]  = iOpen(NULL, 0, i);
      Closes[i] = iClose(NULL, 0, i);
     i--;
     }


// We calculate the matches for each open with the other open bars in the current set +/- 1 pip counts as a match

   // This loop cycles each open bar thru the examination
   int ct=0;
   i = NumberOfBars; 
   for(ct=NumberOfBars;ct>0;ct--)   
      {
         double xt=Opens[i];
        // This loop counts matches for each bar with the other bars
         int cnt=0, match=0, t=NumberOfBars;
         for(cnt=NumberOfBars;cnt>0;cnt--)   
            {
              double tx=Opens[t];          
              if(xt==tx || xt==tx+Point || xt==tx-Point)
                 {
                 match++;
                 }
             t--;   
            }
        // We save the results for each bar
        OpenOMatches[i]=match;
        OpenOLevels[i]=xt;
        match=0;
          
        // We print the result
        //Print("Bar: ",i,"  Open O Level: ",OpenOLevels[i],"   Open O Matches: ",OpenOMatches[i]);       
      i--;
      }
 
   
      
// We calculate the matches for each open with the close bars in the current set +/- 1 pip counts as a match
     
   // This loop cycles each close bar thru the examination
   int ct2=0,i2=0;
   i2 = NumberOfBars; 
   for(ct2=NumberOfBars;ct2>0;ct2--)   
      {
         double xt2=Opens[i2];
        // This loop counts matches for each bar with the other bars
         int cnt2=0, match2=0, t2=NumberOfBars;
         for(cnt2=NumberOfBars;cnt2>0;cnt2--)   
            {
              double tx2=Closes[t2];          
              if(xt2==tx2 || xt2==tx2+Point || xt2==tx2-Point)
                 {
                 match2++;
                 }
             t2--;   
            }
        // We save the results for each bar
        OpenCMatches[i2]=match2;
        OpenCLevels[i2]=xt2;
        match2=0;


        // We print the result
        //Print("Bar: ",i2,"  Open C Level: ",OpenCLevels[i2],"   Open C Matches: ",OpenCMatches[i2]);       
      i2--;
      }   

// We calculate the matches for each close with the other closes bars in the current set +/- 1 pip counts as a match

   // This loop cycles each open bar thru the examination
   int ct1=0,i1=0;
   i1 = NumberOfBars; 
   for(ct1=NumberOfBars;ct1>0;ct1--)   
      {
         double xt1=Closes[i1];
        // This loop counts matches for each bar with the other bars
         int cnt1=0, match1=0, t1=NumberOfBars;
         for(cnt1=NumberOfBars;cnt1>0;cnt1--)   
            {
              double tx1=Closes[t1];          
              if(xt1==tx1 || xt1==tx1+Point || xt1==tx1-Point)
                 {
                 match1++;
                 }
             t1--;   
            }
        // We save the results for each bar
        CloseCMatches[i1]=match1;
        CloseCLevels[i1]=xt1;
        match1=0;
          
        // We print the result
        //Print("Bar: ",i1,"  Close C Level: ",CloseCLevels[i1],"   Close C Matches: ",CloseCMatches[i1]);       
      i1--;
      }
 
   
      
//  We calculate the matches for each close with the opens bars in the current set +/- 1 pip counts as a match
     
   //  This loop cycles each close bar thru the examination
   int ct3=0,i3=0;
   i3 = NumberOfBars; 
   for(ct3=NumberOfBars;ct3>0;ct3--)   
      {
         double xt3=Closes[i3];
         //  This loop counts matches for each bar with the other bars
         int cnt3=0, match3=0, t3=NumberOfBars;
         for(cnt3=NumberOfBars;cnt3>0;cnt3--)   
            {
              double tx3=Opens[t3];          
              if(xt3==tx3 || xt3==tx3+Point || xt3==tx3-Point)
                 {
                 match3++;
                 }
             t3--;   
            }
        // We save the results for each bar
        CloseOMatches[i3]=match3;
        CloseOLevels[i3]=xt3;
        match3=0;


        // We print the result
        //Print("Bar: ",i3,"  Close C Level: ",CloseOLevels[i3],"   Close O Matches: ",Close O Matches[i3]);       
      i3--;
      }
      
// We combine the matches from the opens and closes and make interger arrays of Opens and Closes for the histogram loop to use

   
    int ct4=0,i4=0;
    i4 = NumberOfBars;
    string OpenLevelMatches,CloseLevelMatches;
    for(ct4=NumberOfBars;ct4>0;ct4--)
      {
         TotalOMatches[i4] = OpenOMatches[i4] +  OpenCMatches[i4];
         TotalCMatches[i4] = CloseOMatches[i4] + CloseCMatches[i4];
         OpensInt[i4] = Opens[i4]*10000;
         ClosesInt[i4] = Closes[i4]*10000;

         //We combine the levels and matches
         OpenLevelMatches = StringConcatenate(OpensInt[i4],".",TotalOMatches[i4]);
         CloseLevelMatches = StringConcatenate(ClosesInt[i4],".",TotalCMatches[i4]);
         OpenConcats[i4] = StrToDouble(OpenLevelMatches);
         CloseConcats[i4] = StrToDouble(CloseLevelMatches);

         // We Print the tallies of the  matches
         //Print("Bar: ",i4," Array Concats: ",OpenConcats[i4],"  Concat: ",OpenLevelMatches," OpensInt: ",OpensInt[i4]," Opens: ",Opens[i4],"  Total Open Matches: ",TotalOMatches[i4]);
         //Print ("Bar: ",i4," Array Concats: ",OpenConcats[i4],"  Concat: ",CloseLevelMatches," ClosesInt: ",ClosesInt[i4]," Closes: ",Closes[i4],"  Total Close Matches: ",TotalCMatches[i4]);
         
         
         //Print("Bar: ",i4,"Interger of TotalM: ",OpensInt[i4],"  Total Open Matches: ",TotalOMatches[i4]," =  OoM: ",OpenOMatches[i4]," @L: ",OpenOLevels[i4],"   + OcM: ",OpenCMatches[i4]," @L: ",OpenCLevels[i4]);
         //Print ("Bar: ",i4,"Interger of TotalM: ",ClosesInt[i4],"  Total Close Matches: ",TotalCMatches[i4],"  = CoM: ",CloseOMatches[i4]," @L: ",CloseOLevels[i4],"  + CcM: ",CloseCMatches[i4]," @L: ",CloseCLevels[i4]);
         //Print("Bar: ",i4," TotalM: ",Opens[i4],"  Total Open Matches: ",TotalOMatches[i4]," =  OoM: ",OpenOMatches[i4]," @L: ",OpenOLevels[i4],"   + OcM: ",OpenCMatches[i4]," @L: ",OpenCLevels[i4]);
         //Print ("Bar: ",i4," TotalM: ",Closes[i4],"  Total Close Matches: ",TotalCMatches[i4],"  = CoM: ",CloseOMatches[i4]," @L: ",CloseOLevels[i4],"  + CcM: ",CloseCMatches[i4]," @L: ",CloseCLevels[i4]);

      i4--;
      }
   
   //another attempt to get the histogram
   //we combine the concatenates of the opens and closes and eliminate duplicates 
    
      
/////////////////////////////////////////


   int ct5=0,ct6=0,i5=NumberOfBars,i6=NumberOfBars;
   ConcatTracker=0;
   for(ct5=NumberOfBars;ct5>0;ct5--) 
      {
         //Print("Starting bar: ",i5," open: ",OpenConcats[i5]," close: ",CloseConcats[i5]," combined: ",CombinedConcats[i5]);
         if(OpenConcats[i5]==0)//we eliminate the zero value from the array 
            {
            i5--;
            continue;
            }
         if(OpenConcats[i5]>0)
            {
            //Print("Opens bar: ",i5,"  ",OpenConcats[i5]);
            for(ct6=NumberOfBars;ct6>0;ct6--)
            if(CloseConcats[i6]==0) 
               {
               i6--;
               continue;
               }
            if(CloseConcats[i6]>0)
               {
               //Print("Closes bar: ",i6,"  ",CloseConcats[i6]);
                  if(OpenConcats[i5] != CloseConcats[i6]) 
                     {
                     ONotEqualCConcats[i5] = OpenConcats[i5];// This stores the open values that are not found in the closes therefore it is 1/2 cleared it still has to filter out those which are duplicated in the opens
                     ConcatTracker++;
                    // Print("bar: ",i5," ONotEqualCConcats: ",ONotEqualCConcats[i5]);
                     }                 
               }         
            i6--;
            }        
      i5--;   
      }// Everything down to this point works great....
      
      
//////////////////////////////////////yet another approach cycling thru the array itself...
   int OnotequalC=0;
   OnotequalC = NumberOfBars-ConcatTracker;    
   ConcatTracker=0;
   
   
   int ct7=0,ct8=0,i8=NumberOfBars-OnotequalC,i9=NumberOfBars-OnotequalC;
   for(ct7=NumberOfBars-OnotequalC;ct7>0;ct7--)     
      {
         if(ONotEqualCConcats[i8] != ONotEqualCConcats[i9])
            {
            CombinedConcats[i8] = ONotEqualCConcats[i8];
            //Print("bar: ",i8," Unique Concats: ",CombinedConcats[i8]);
            }
       i9--;     
      } 
      
 //Any help with the last part of this is appreciated.     
   int i10 = NumberOfBars;
   int ct10=0;
   for(ct10=NumberOfBars;ct10>0;ct10--)
     {
      Print("bar: ",i10," Unique Concats: ",CombinedConcats[i10]);
      Print("Bar: ",i10," Array Concats: ",OpenConcats[i10],"  Concat: ",OpenLevelMatches," OpensInt: ",OpensInt[i10]," Opens: ",Opens[i10],"  Total Open Matches: ",TotalOMatches[i10]);
      Print ("Bar: ",i10," Array Concats: ",OpenConcats[i10],"  Concat: ",CloseLevelMatches," ClosesInt: ",ClosesInt[i10]," Closes: ",Closes[i10],"  Total Close Matches: ",TotalCMatches[i10]);
      
     i10--;
     }     
/*      
   int OnotequalC=0;
   OnotequalC = NumberOfBars-ConcatTracker;    
   ConcatTracker=0;
/////////////////////////////////////////////
//The last half of filtering is supposed to remove values which are duplicated exclusively within the opens but which are still in the ONotEqualCConcats[i]

   int ct7=0,ct8=0,i8=NumberOfBars,i9=NumberOfBars-OnotequalC;
   for(ct7=NumberOfBars;ct7>0;ct7--) 
      {
         //Print("Starting bar: ",i8," open: ",OpenConcats[i8]," ONotEqualCConcats: ",ONotEqualCConcats[i8]," combined: ",CombinedConcats[i8]);
         if(OpenConcats[i8]==0)//we eliminate the zero value from the array 
            {
            i8--;
            continue;
            }
         if(OpenConcats[i8]>0)
            {
               //Print("Not Unique OpenConcats: ",i8,"  ",OpenConcats[i8]);
               for(ct8=NumberOfBars;ct8>0;ct8--)
               {
                  if(ONotEqualCConcats[i9]==0) 
                     {
                     i9--;
                     continue;
                     }
                  if(ONotEqualCConcats[i9]>0)
                     {
                        //Print("Not unique ONotEqualC Concats: ",i9,"  ",ONotEqualCConcats[i9]);
                        if(OpenConcats[i8] != ONotEqualCConcats[i9])
                           {
                           CombinedConcats[i8] = OpenConcats[i8];
                           Print("bar: ",i8," Unique Concats: ",CombinedConcats[i8]);
                           }              
                        i9--;                
                     }       
               }//for
            i8--;   
            }//if       
      }//for 
   OnotequalC=0;



*/
//////////////////////////////////////////////       
      Print("Support and Resistance EA has finished");
//----
return(0);
}
//+------------------------------------------------------------------+

